'use strict';

var Faye = require('../faye');
var Faye_Class = require('../util/class');
var Faye_Deferrable = require('../mixins/deferrable');

var Faye_Subscription = Faye_Class({
  initialize: function(client, channels, callback, context) {
    this._client    = client;
    this._channels  = channels;
    this._callback  = callback;
    this._context     = context;
    this._cancelled = false;
  },

  cancel: function() {
    if (this._cancelled) return;
    this._client.unsubscribe(this._channels, this._callback, this._context);
    this._cancelled = true;
  },

  unsubscribe: function() {
    this.cancel();
  }
});

Faye.extend(Faye_Subscription.prototype, Faye_Deferrable);

module.exports = Faye_Subscription;
